public class Example {

  public void printVec (byte [] v) {
    if(v == null) {
      System.out.println("Null vector");
      return;
    }

    for( int i=0 ; i < v.length ; i++ ) {
      System.out.print(v[i]);
      if(i < v.length - 1) 
        System.out.print(", ");
    }
    System.out.println();
  }

  public void printVec (int [] v) {
    if(v == null) {
      System.out.println("Null vector");
      return;
    }

    for( int i=0 ; i < v.length ; i++ ) {
      System.out.print(v[i]);
      if(i < v.length - 1) 
        System.out.print(", ");
    }
    System.out.println();
  }

  public void printVec (char [] v) {
    if(v == null) {
      System.out.println("Null vector");
      return;
    }

    for( int i=0 ; i < v.length ; i++ ) {
      System.out.print(v[i]);
      if(i < v.length - 1) 
        System.out.print(", ");
    }
    System.out.println();
  }

  public void printVec (float [] v) {
    if(v == null) {
      System.out.println("Null vector");
      return;
    }

    for( int i=0 ; i < v.length ; i++ ) {
      System.out.print(v[i]);
      if(i < v.length - 1) 
        System.out.print(", ");
    }
    System.out.println();
  }

  public void printVec (double [] v) {
    if(v == null) {
      System.out.println("Null vector");
      return;
    }

    for( int i=0 ; i < v.length ; i++ ) {
      System.out.print(v[i]);
      if(i < v.length - 1) 
        System.out.print(", ");
    }
    System.out.println();
  }

  public void printComplex(float [] v) {
    printComplex(v[0],v[1]);
    System.out.println();
  }

  public void printComplex(double [] v) {
    printComplex(v[0],v[1]);
    System.out.println();
  }

  public void printComplex(float real, float img) {
    if(img >= 0)
      System.out.print(real + "+" + img + "i");
    else
      System.out.print(real + img + "i");
  }

  public void printComplex(double real, double img) {
    if(img >= 0)
      System.out.print(real + "+" + img + "i");
    else
      System.out.print(real + img + "i");
  }

  public void printComplexVec (float [] v) {
    if(v == null) {
      System.out.println("Null vector");
      return;
    }

    for( int i=0 ; i < v.length ; i+=2 ) {
      printComplex(v[i],v[i+1]);
      if(i < v.length - 2) 
        System.out.print(", ");
    }
    System.out.println();
  }

  public void printComplexVec (double [] v) {
    if(v == null) {
      System.out.println("Null vector");
      return;
    }

    for( int i=0 ; i < v.length ; i+=2 ) {
      printComplex(v[i],v[i+1]);
      if(i < v.length - 2) 
        System.out.print(", ");
    }
    System.out.println();
  }

  public void printMat (byte [][] v) {
    int i,j;

    if(v == null) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v.length ; i++ ) {
      if(v[i] == null) {
        System.out.println("Null vector");
        return;
      }

      for( j=0 ; j < v[i].length ; j++ ) {
        System.out.print(v[i][j]);
        if(j < v[i].length - 1) 
          System.out.print(", ");
      }
      System.out.println();
    }
  }

  public void printMatColMajor (byte [][] v) {
    int i,j;

    // Assumes all rows are equal length

    if( (v == null) || (v[0] == null) ) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v[0].length ; i++ ) {
      for( j=0 ; j < v.length ; j++ ) {
        System.out.print(v[j][i]);
        if(j < v.length - 1) 
          System.out.print(", ");
      }
      System.out.println();
    }
  }

  public void printMat (int [][] v) {
    int i,j;

    if(v == null) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v.length ; i++ ) {
      if(v[i] == null) {
        System.out.println("Null vector");
        return;
      }

      for( j=0 ; j < v[i].length ; j++ ) {
        System.out.print(v[i][j]);
        if(j < v[i].length - 1) 
          System.out.print(", ");
      }
      System.out.println();
    }
  }

  public void printMatColMajor (int [][] v) {
    int i,j;

    // Assumes all rows are equal length

    if( (v == null) || (v[0] == null) ) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v[0].length ; i++ ) {
      for( j=0 ; j < v.length ; j++ ) {
        System.out.print(v[j][i]);
        if(j < v.length - 1) 
          System.out.print(", ");
      }
      System.out.println();
    }
  }

  public void printMat (char [][] v) {
    int i,j;

    if(v == null) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v.length ; i++ ) {
      if(v[i] == null) {
        System.out.println("Null vector");
        return;
      }

      for( j=0 ; j < v[i].length ; j++ ) {
        System.out.print(v[i][j]);
        if(j < v[i].length - 1) 
          System.out.print(", ");
      }
      System.out.println();
    }
  }

  public void printMatColMajor (char [][] v) {
    int i,j;

    // Assumes all rows are equal length

    if( (v == null) || (v[0] == null) ) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v[0].length ; i++ ) {
      for( j=0 ; j < v.length ; j++ ) {
        System.out.print(v[j][i]);
        if(j < v.length - 1) 
          System.out.print(", ");
      }
      System.out.println();
    }
  }

  public void printMat (float [][] v) {
    int i,j;

    if(v == null) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v.length ; i++ ) {
      if(v[i] == null) {
        System.out.println("Null vector");
        return;
      }

      for( j=0 ; j < v[i].length ; j++ ) {
        System.out.print(v[i][j]);
        if(j < v[i].length - 1) 
          System.out.print(", ");
      }
      System.out.println();
    }
  }

  public void printMatColMajor (float [][] v) {
    int i,j;

    // Assumes all rows are equal length

    if( (v == null) || (v[0] == null) ) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v[0].length ; i++ ) {
      for( j=0 ; j < v.length ; j++ ) {
        System.out.print(v[j][i]);
        if(j < v.length - 1) 
          System.out.print(", ");
      }
      System.out.println();
    }
  }

  public void printMat (double [][] v) {
    int i,j;

    if(v == null) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v.length ; i++ ) {
      if(v[i] == null) {
        System.out.println("Null vector");
        return;
      }

      for( j=0 ; j < v[i].length ; j++ ) {
        System.out.print(v[i][j]);
        if(j < v[i].length - 1) 
          System.out.print(", ");
      }
      System.out.println();
    }
  }

  public void printMatColMajor (double [][] v) {
    int i,j;

    // Assumes all rows are equal length

    if( (v == null) || (v[0] == null) ) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v[0].length ; i++ ) {
      for( j=0 ; j < v.length ; j++ ) {
        System.out.print(v[j][i]);
        if(j < v.length - 1) 
          System.out.print(", ");
      }
      System.out.println();
    }
  }

  public void printComplexMat (float [][] v) {
    int i,j;

    if(v == null) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v.length ; i++ )
      printComplexVec(v[i]);
  }

  public void printComplexMatColMajor (float [][] v) {
    int i,j;

    // Assumes all rows are equal length

    if( (v == null) || (v[0] == null) ) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v[0].length ; i+=2 ) {
      for( j=0 ; j < v.length ; j++ ) {
        printComplex(v[j][i], v[j][i+1]);
        if(j < v.length - 1) 
          System.out.print(", ");
      }
      System.out.println();
    }
  }

  public void printComplexMat (double [][] v) {
    int i,j;

    if(v == null) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v.length ; i++ )
      printComplexVec(v[i]);
  }

  public void printComplexMatColMajor (double [][] v) {
    int i,j;

    // Assumes all rows are equal length

    if( (v == null) || (v[0] == null) ) {
      System.out.println("Bad matrix");
      return;
    }

    for( i=0 ; i < v[0].length ; i+=2 ) {
      for( j=0 ; j < v.length ; j++ ) {
        printComplex(v[j][i], v[j][i+1]);
        if(j < v.length - 1) 
          System.out.print(", ");
      }
      System.out.println();
    }
  }
}
