/*
 * This small example shows how the User Provided Function 
 * mechanism works
 */

#include <stdio.h>
#include "netsolve.h"

main(argc,argv)
int argc;
char **argv;
{
  int A,B;
  int info;
  char upf0[256];
  char upf1[256];

   if (argc != 3)
   { 
     fprintf(stderr,"Usage : %s <integer> <directory containing upf.*>\n",argv[0]);
     fprintf(stderr,"    Default upf directory is in ../../examples/UPF_try_C/\n");
     exit(0);
   }
   A = atoi(argv[1]);

   sprintf(upf0,"%s/upf",argv[2]);
   sprintf(upf1,"%s/upf1",argv[2]);

   fprintf(stderr,"Sending a blocking request to NetSolve\n");
   info = netsl("upftest()",upf0,upf1,&A,&B);
   if (info <0)
   {
     netslerr(info);
     exit(0);
   }
   fprintf(stderr,"*************\n");
   fprintf(stderr,"** Success **\n");
   fprintf(stderr,"*************\n");
   printf("Result : %d\n",B);
}
