/*****************************************************************/
/*      netslpr.c                                                */
/*      Version 1.0                      Henri Casanova          */
/*---------------------------------------------------------------*/
/*  netslpr()                                                    */
/*****************************************************************/

#include "netsolve.h"

/*
 * netslpr() : Check the status of a pending request
 *     mode = PROBE  - non-blocking
 */

#ifdef __STDC__
int netslpr(int r)
#else
int netslpr(r)
int r;
#endif
{
  int status;

#if THREADS
  if (request[r] == NULL)
  {
    sprintf(error_message,"%s (%d) \n\t\t[%s,%d]",
      "Invalid request number",r,
      __FILE__,__LINE__);
    return NetSolveInvalidRequestNumber;
  }

  if (request[r]->thread_status == THREAD_RUNNING)
  {
    return NetSolveNotReady;
  }

  if (request[r]->thread_status == THREAD_DONE)
  {
    pthread_join(request[r]->thread_id,NULL);
    status = request[r]->NetSolve_error_code;
    pthread_mutex_lock(&thread_mutex);
    free(request[r]->command_name);
    free(request[r]);
    request[r] = NULL;
    pthread_mutex_unlock(&thread_mutex);
    return status;
  }
#endif

#ifdef NOTHREADS
  return nothread_get_result(r,PROBE);
#endif

}
