/*****************************************************************/
/*      netslwt.c                                                */
/*      Version 1.0                      Henri Casanova          */
/*---------------------------------------------------------------*/
/*  netslwt()                                                    */
/*****************************************************************/

#include "netsolve.h"

/*
 * netslwt() : Check the status of a pending request
 *     mode = WAIT  - blocking
 */

#ifdef __STDC__
int netslwt(int r)
#else
int netslwt(r)
int r;
#endif
{
  int status;

#ifdef THREADS
  if (request[r] == NULL) 
  {
    sprintf(error_message,"%s (%d) \n\t\t[%s,%d]",
      "Invalid request number",r,
      __FILE__,__LINE__);
    return NetSolveInvalidRequestNumber;
  }

  pthread_join(request[r]->thread_id,NULL);
  status = request[r]->NetSolve_error_code;
  pthread_mutex_lock(&thread_mutex);
  free(request[r]->command_name);
  free(request[r]);
  request[r] = NULL;
  pthread_mutex_unlock(&thread_mutex);
  return status;;
#endif

#ifdef NOTHREADS
  return nothread_get_result(r,WAIT);
#endif

}
