/**
* ByteParser
*   
* This class contains methods to parse byte data.  These are
* primarily called from the NetSolveInt{Scalar,Vector,Matrix}
* classes.
* 
* @version 1.1, 26 Jan 1998
* @author Keith Seymour (seymour@cs.utk.edu)
*
**/

import java.util.StringTokenizer;

public class ByteParser {

  /**
   *
   *  This method parses a line of text into an array of
   * bytes.
   *
   * @param line A string containing the input.
   * @param err A buffer to which error messages are appended.
   *
   * @return Array of bytes, cast to Object.
   *
   **/

  public static Object parseLine(String line, StringBuffer err) {
    boolean err_status = false, isTok = false;
    int items = 0, temp_int;
    String temp = null;
    Object return_object = null;

    StringTokenizer st = new StringTokenizer(line);
    int tokCount = st.countTokens();
    byte [] byte_arr = new byte [tokCount];

    while(tokCount-- > 0) {
      try {
        temp = st.nextToken();
        temp_int = Integer.valueOf(temp).intValue();
        if(temp_int > 255)
          throw new NumberFormatException("val too big for byte");
        byte_arr[items] = (byte) temp_int;
        items++;
      }catch (NumberFormatException e) {
        err_status = true;
        err.append(Labels.invalid_byte[Labels.language]+temp+"\n");
      }
    }

    if(err_status)
      return null;
    else
      return byte_arr;
  }
}
