/**
* DcomplexParser
*   
* This class contains methods to parse double precision 
* complex numbers.  These are primarily called from the 
* NetSolveDcomplex{Scalar,Vector,Matrix} classes.
* 
* @version 1.1, 26 Jan 1998
* @author Keith Seymour (seymour@cs.utk.edu)
*
**/

import java.util.StringTokenizer;

public class DcomplexParser extends ComplexParser {

  /**
   *
   *  This method parses a line of text into an array of
   * doubles.
   *
   * @param mat The complex matrix object.
   * @param line A string containing the input.
   * @param err A buffer to which error messages are appended.
   *
   * @return Array of doubles, cast to Object.
   *
   **/

  public static Object parseLine( String line, StringBuffer err) 
  {
    double [] dcomplex = null;
    int idx, temp_length;

    dcomplex = parseComplex(line,err);

    // since parseComplex already returns an array of doubles
    // we just return it as-is unless there has been an error.

    if(err.length() > 0)
      return null;
    else
      return dcomplex;
  }
}
