/**
* ImagePanel
*   
* This is a simple class to allow loading an image from a
* file and displaying it on a panel.  MediaTracker is used
* to track the loading status.
* 
* @version 1.1, 26 Jan 1998
* @author Keith Seymour (seymour@cs.utk.edu)
*
**/

import java.lang.*;
import java.applet.*;
import java.awt.*;
import java.net.URL;

public class ImagePanel extends Panel
{
  Image im=null;
  MediaTracker tracker;

  /**
   *
   * This is the constructor for the ImagePanel class.
   * It loads the image using MediaTracker and displays
   * the image to the panel.  This will have to be modified
   * somewhat to work in an applet since it won't be able
   * to read from a file.
   * 
   * @param filename The filename of the image.
   *
   **/

  public ImagePanel(String filename)
  {
    super();
    setSize(100,100);

    // Load the image from the specified file
    im = Toolkit.getDefaultToolkit().getImage(filename);

    tracker = new MediaTracker(this);
    tracker.addImage(im,1);

    try {
     // wait for the image to load
     tracker.waitForID(1);
    } catch(InterruptedException e) {
     System.err.println("Error loading image.");
     return;
    }
    repaint();
  }

/*  this routine doesn't seem to be working

  public ImagePanel(Applet a,URL urlname)
  {
    super();
    setSize(100,100);

    try {
      im = (Image) urlname.openConnection().getContent();
      
    }catch (java.io.IOException ee) {
      System.err.println("Error loading image.");
      return;
    }

    tracker = new MediaTracker(this);
    tracker.addImage(im,1);

    try {
     // wait for the image to load
     tracker.waitForID(1);
    } catch(InterruptedException e) {
     System.err.println("Error loading image.");
     return;
    }
    repaint();
  }

*/
  /**
   *
   * Redraws the image by calling update().
   * 
   * @param g The graphics context.
   *
   * @see #update
   *
   **/

  public void paint(Graphics g)
  {
    update(g);
  }

  /**
   *
   * This method re-draws the image.
   * 
   * @param g The graphics context.
   *
   **/

  public void update(Graphics g)
  {
    g.drawImage(im, 0, 0, this);
  }
}
