/**
* NSApplet
*
* This class starts the NetSolve Java interface as an applet.
* 
* @version 1.1, 26 Jan 1998 
* @author Keith Seymour (seymour@cs.utk.edu)
*
**/

import java.applet.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class NSApplet extends Applet 
 implements ActionListener {
  private Button start_gui;

  /**
   *
   *  This method is called when running as an applet.  Create
   *  a button that appears on the web page and opens up the
   *  main GUI screen.
   *
   **/

  public void init() {
    start_gui = new Button("Click here to start the Java interface");
    start_gui.addActionListener(this);
    this.add(start_gui);
    this.setVisible(true);
  }

  /**
   * 
   * This is the method which is called whenever an action event happens.
   * First, determine the source of the event.  Then execute the code
   * associated with this event.
   * 
   * @param event The event that was generated.
   *
   **/

  public void actionPerformed(ActionEvent event)
  {
    NetSolveClient ns;
    Object source = event.getSource();

    if(source == start_gui)
      ns = new NetSolveClient("kenner.cs.utk.edu");
  }
}
