/**
* NetSolveASCII
*   
* This class contains a character array and methods for reading,
* writing, and parsing character data.
* 
* @version 1.1, 8 Apr 1998
* @author Keith Seymour (seymour@cs.utk.edu)
*
* @see NetSolveCharVector
**/

import java.io.InputStream;
import java.lang.Thread;

public class NetSolveASCII extends NetSolveCharVector {

  /**
   *
   *  This method returns a String representation of
   * the character array.
   *
   * @return String representation of the array.
   *
   **/

  public String toString() {

    if(val.length == 0) 
      return("Empty result");

    return(new String(val));
  }

  public String sampleData(int rand) {
    return(new String("Type your FILE here."));
  }

  public void setDataType() {
    data_type = NETSOLVE_ASCII;
    object_type = NETSOLVE_FILE;
  }

  public NetSolveASCII ()
  {
    super();
  }

  public NetSolveASCII (InputStream in, Thread p) throws NetSolveException
  {
    initialize(in,p);
  }

  public NetSolveASCII (char [] text) throws NetSolveException {
    super.initialize(text);
  }

  public void initialize(InputStream in, Thread p) throws NetSolveException
  {
    super.initialize(in,p);
  }

  public void initialize (char [] text) throws NetSolveException {
    super.initialize(text);
  }

  /**
   *
   *  This method parses a line of text into an array of
   * characters.
   *
   * @param line A string containing the input.
   * @param err A buffer to which error messages are appended.
   *
   * @return Array of characters, cast to Object.
   *
   **/

  public Object parseLine(String line, StringBuffer err) {
    return((line + "\n").toCharArray());
  }

  public void copy(NetSolveASCII obj) {
    super.copy(obj);
  }
}
