/**
* NetSolveThread
*
* @version 1.1, 26 Jan 1998 
* @author Keith Seymour (seymour@cs.utk.edu)
*
**/

import java.awt.AWTEvent;
import java.awt.AWTEventMulticaster;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class NetSolveThread extends Thread {
  ActionListener actionListener = null;
  private boolean hasCompleted = false;

  /* 
   * All this 'completed' stuff is just to signify that the
   * thread has finished what it needs to do, but may not be
   * officially stopped yet.  that is, the isAlive() method 
   * of the thread may still return true even though the thread
   * has posted an event to signify that it is done.  This is
   * for the benefit of ThreadList - so that its display is
   * updated more accurately.
   */

  public void setCompleted(boolean val) {
    hasCompleted = val;
  }

  public boolean completed() {
    return hasCompleted;
  }

  public void addActionListener(ActionListener l) {
    actionListener = AWTEventMulticaster.add(actionListener, l);
  }

  public void removeActionListener(ActionListener l) {
    actionListener = AWTEventMulticaster.remove(actionListener, l);
  }

  public void processEvent(AWTEvent e) {
    if(GlobalDefs.DEBUG)
      System.out.println("in processEvent");

    if (actionListener != null) {
      if(GlobalDefs.DEBUG)
        System.out.println("calling actionPerformed()");
       
      actionListener.actionPerformed(
        new ActionEvent(this,(int)AWTEvent.ACTION_EVENT_MASK,"hi there")
      );
                  //    ^^^ should that really be 'this'? seems to work.
    }
  }
}  // end class NetSolveThread
