import java.io.IOException;

public abstract class NetSolveVector extends NetSolveObject {

  public void setDims(int lines, int last, int total)
  {
    m = 0;
    n = total;
  }
  
  public void readVectorHeader(NetSolveStream s)
   throws IOException
  {

    // First, read the data type and object type.  we dont
    // care about this because we already know the types.

    s.server_in.readInt();   // read data type
    s.server_in.readInt();   // read object type

    n = s.server_in.readInt();

    if(GlobalDefs.DEBUG)
      System.out.println("vector is size " + n);

  }

  public void writeVectorHeader(NetSolveStream s)
   throws IOException
  {
    s.sendType(data_type, object_type);

    if(GlobalDefs.DEBUG)
      System.out.println("sending n = " + n);

    s.server_out.writeInt(n);     // first send n (num elements)
  }

  public NetSolveVector() {
    super();
  }
  
  public void copy(NetSolveVector obj) {
    super.copy(obj);
  }
}
