/**
* ScomplexParser
*   
* This class contains methods to parse single precision 
* complex numbers.  These are primarily called from the 
* NetSolveScomplex{Scalar,Vector,Matrix} classes.
* 
* @version 1.1, 26 Jan 1998
* @author Keith Seymour (seymour@cs.utk.edu)
*
**/

import java.util.StringTokenizer;

public class ScomplexParser extends ComplexParser {

  /**
   *
   *  This method parses a line of text into an array of
   * floats.
   *
   * @param obj The complex object.
   * @param line A string containing the input.
   * @param err A buffer to which error messages are appended.
   *
   * @return Array of floats, cast to Object.
   *
   **/

  public static Object parseLine(String line, StringBuffer err) 
  {
    double [] temp_array = null;
    float [] scomplex = null;
    int idx, temp_length;

    temp_array = parseComplex(line,err);

    // parseComplex always returns a double array, so we copy it
    // to float here.

    if(temp_array != null) {
      temp_length = temp_array.length;
      scomplex = new float[temp_length];
      for(idx=0;idx<temp_length;idx++) {
        scomplex[idx] = (float) temp_array[idx];
        if(GlobalDefs.DEBUG)
          System.out.println("scomplex ["+idx+"] = " + scomplex[idx]);
      }
    }

    if(err.length() > 0)
      return null;
    else
      return scomplex;
  }
}
