/**
* ScreenList
*   
* This class contains methods to keep track of all the screens that
* that the GUI has opened.  This allows the GUI to clean up all the
* windows when it exits.
* 
* @version 1.1, 26 Jan 1998
* @author Keith Seymour (seymour@cs.utk.edu)
*
**/

import java.awt.Frame;
import java.util.Vector;
import java.lang.*;

public class ScreenList extends Vector {
  private Vector screen_list;

  /**
   *
   * This is the constructor for the ScreenList class.  It just
   * calls the constructor of the superclass, Vector.
   * 
   **/

  public ScreenList() {
    super();
  }

  /**
   *
   * This is the constructor for the ScreenList class.  It just
   * calls the constructor of the superclass, Vector, providing
   * the initial size for the list.
   *
   * @param initial_size The number of elements to start out with.
   *
   **/

  public ScreenList(int initial_size) {
    super(initial_size);
  }

  /**
   *
   * This method attempts to destroy each screen in the list.
   *
   **/

  public void disposeAll() {
    for(int i=0;i<elementCount;i++) {
      if(this.elementAt(i) != null) {
        try {
          ((Frame)this.elementAt(i)).dispose();
        } catch (Exception e) {
           ; // do nothing - probably NoSuchMethodException
        }
      }
    }
  }
} // end class ScreenList
