/*****************************************************************/
/*      matlab_status.c                                          */
/*      Version 1.0                      Henri Casanova          */
/*****************************************************************/

#include "mex.h"
#include "interface.h"
#include "matlab_netsolve.h"

#define BYTE(x,y) (((unsigned char *)x)[(y)]&0xff)

int is_sigpipe;

/*
 * matlab_status()
 */
        
void matlab_status()
{
  int client_type = MATLAB;
  problem_desc *pb_desc;

  int i,j;
  long t;
  int off = 0;
  int on = 1;
  int ok;
  char buf;
  int try;

  mexPrintf("Pending NetSolve requests :\n");
#ifdef MATLABNOTHREADS
  for (i=0;i<MAX_REQUEST;i++)
    if (request[i]  != 0)
    {
      pb_desc = Xpb_desc[i];
      time((time_t *)(&t));
      t = t - Xtime[i];
      mexPrintf("Request #%d - %s\n",i,pb_desc->code);
      mexPrintf("\tAssigned to %s %d seconds ago\n",
              Xserver_name[i],t);

      /* Is it done or not */
      try = ioctl(Xdesc[i],FIONBIO,&on);
      ok = recv(Xdesc[i],&buf,1,MSG_PEEK);
      ioctl(Xdesc[i],FIONBIO,&off);

      /* Print the appropriate message */
      if (ok == 0)
      {
        mexPrintf("\tConnection has been broken\n");
        mexPrintf("\tdo a netsolve_nb('probe',...) to try again\n");
      }
      else if (ok == 1)
      {
        mexPrintf("\tResult AVAILABLE\n");
      }
      else if (ok == -1) /* Not done */
      {
        mexPrintf("\tStill RUNNING\n");
        if (Xexpected[i]-t > 0)
          mexPrintf("\tPredicted execution time  : %d seconds\n",Xexpected[i]);
      }
    }
#endif

#ifdef MATLABTHREADS
  for (i=0;i<MAX_REQUEST;i++)
  {
    if (request[i] == NULL)
      continue;
    time(&t);
    t = t - Xtime[i];
    mexPrintf("Request #%d - %s\n",i,request[i]->command_name);
    mexPrintf("\tAssigned to %s %d seconds ago\n",
              Xserver_name[i],t);
    if (request[i]->thread_status == THREAD_DONE)
    {
      mexPrintf("\tResult AVAILABLE\n");
    }
    else if (request[i]->thread_status == THREAD_DONE)
    {
      mexPrintf("\tStill RUNNING\n");
      if (Xexpected[i]-t > 0)
          mexPrintf("\tPredicted execution time  : %d seconds\n",Xexpected[i]);
    }
    else if (request[i]->thread_status == THREAD_ERROR)
    {
      mexPrintf("\tFAILED\n");
    }
  }
#endif
}
