#include "interface.h"

/*
 * WARNING: constant string returned
 */

char* netsolve_error(int status)
{
  switch (status) {
  case NetSolveNotReady:
    return "not ready";
  case NetSolveSuccess:
    return "no error";
  case NetSolveBadValues:
    return "Bad arguments values";
  case NetSolveFailure:
    return "failure";
  case NetSolveBadCode:
    return "invalid problem code";
  case NetSolveBadCallingSequence:
    return "invalid calling sequence passed to NetSolve";
  case NetSolveUnknownProblem:
    return "unknown problem";
  case NetSolveBadInput:
    return "bad input";
  case NetSolveBadOutput:
    return "bad output";
  case NetSolveAgentFailure:
    return "AGENT FAILURE";
  case NetSolveNoServers:
    return "NO SERVER AVAILABLE";
  case NetSolveBadDimension:
    return "DIMENSIONS DO NOT FIT";
  case NetSolveNoSolution:
    return "NO SOLUTION";
  case NetSolveRequestFull:
    return "no more requests";
  case NetSolveInvalidRequestNumber:
    return "invalid request number";
  case NetSolveSetArch:
    return "NETSOLVE_ARCH variable undefined";
  case NetSolveSetAgent:
    return "NETSOLVE_AGENT variable undefined";
  case NetSolveNoAgent:
    return "SERVER UNREACHABLE";
  default:
    return "invalid error";
  }
}

void display_netsolve_error(int status)
{
  mexPrintf("----------------\n");
  mexPrintf("NetSolve Client: %s\n", netsolve_error(status));
  mexPrintf( "----------------\n");
}
