C 
C   Test program for NetSolve.
C
C    This program is testing the FORTRAN interface to NetSolve
C
C 

      PROGRAM EXAMPLE

      INCLUDE '../include/fnetsolve.h'

      INTEGER NB_REQUESTS
      PARAMETER(NB_REQUESTS = 5)
      INTEGER MAX
      PARAMETER(MAX = 300)

      INTEGER M
      DOUBLE PRECISION A1(MAX,MAX)
      DOUBLE PRECISION B1(MAX)
      INTEGER PIVOT(MAX)
      INTEGER IERR

      INTEGER I,J
      INTEGER INIT
      INTEGER INFO
      INTEGER REQUEST

      INTEGER REQUESTS(NB_REQUESTS)
      INTEGER GOON

C
C     Stuff fo Test #5
C
      INTEGER OK

      INTEGER   INTSCALAR
      CHARACTER CHARSCALAR
      CHARACTER BYTESCALAR
      REAL      FLOATSCALAR
      DOUBLE    PRECISION DOUBLESCALAR
      COMPLEX   SCOMPLEXSCALAR
      DOUBLE    COMPLEX DCOMPLEXSCALAR

      INTEGER   INTVECTORM
      PARAMETER(INTVECTORM = 2)
      INTEGER   CHARVECTORM
      PARAMETER(CHARVECTORM = 2)
      INTEGER   BYTEVECTORM
      PARAMETER(BYTEVECTORM = 2)
      INTEGER   FLOATVECTORM
      PARAMETER(FLOATVECTORM = 2)
      INTEGER   DOUBLEVECTORM
      PARAMETER(DOUBLEVECTORM = 2)
      INTEGER   SCOMPLEXVECTORM
      PARAMETER(SCOMPLEXVECTORM = 2)
      INTEGER   DCOMPLEXVECTORM
      PARAMETER(DCOMPLEXVECTORM = 2)
    
      INTEGER   INTVECTOR(INTVECTORM)
      CHARACTER CHARVECTOR(CHARVECTORM)
      CHARACTER BYTEVECTOR(BYTEVECTORM)
      REAL      FLOATVECTOR(FLOATVECTORM)
      DOUBLE    PRECISION DOUBLEVECTOR(DOUBLEVECTORM)
      COMPLEX   SCOMPLEXVECTOR(SCOMPLEXVECTORM)
      DOUBLE    COMPLEX DCOMPLEXVECTOR(DCOMPLEXVECTORM)
  
      INTEGER   INTMATRIXM 
      INTEGER   INTMATRIXN 
      INTEGER   INTMATRIXL 
      PARAMETER(INTMATRIXM = 2)
      PARAMETER(INTMATRIXN = 2)
      PARAMETER(INTMATRIXL = 2)
      INTEGER   CHARMATRIXM 
      INTEGER   CHARMATRIXN
      INTEGER   CHARMATRIXL
      PARAMETER(CHARMATRIXM = 2)
      PARAMETER(CHARMATRIXN = 2)
      PARAMETER(CHARMATRIXL = 2)
      INTEGER   BYTEMATRIXM 
      INTEGER   BYTEMATRIXN
      INTEGER   BYTEMATRIXL
      PARAMETER(BYTEMATRIXM = 2)
      PARAMETER(BYTEMATRIXN = 2)
      PARAMETER(BYTEMATRIXL = 2)
      INTEGER   FLOATMATRIXM 
      INTEGER   FLOATMATRIXN
      INTEGER   FLOATMATRIXL
      PARAMETER(FLOATMATRIXM = 2)
      PARAMETER(FLOATMATRIXN = 2)
      PARAMETER(FLOATMATRIXL = 2)
      INTEGER   DOUBLEMATRIXM 
      INTEGER   DOUBLEMATRIXN
      INTEGER   DOUBLEMATRIXL
      PARAMETER(DOUBLEMATRIXM = 2)
      PARAMETER(DOUBLEMATRIXN = 2)
      PARAMETER(DOUBLEMATRIXL = 2)
      INTEGER   SCOMPLEXMATRIXM 
      INTEGER   SCOMPLEXMATRIXN
      INTEGER   SCOMPLEXMATRIXL
      PARAMETER(SCOMPLEXMATRIXM = 2)
      PARAMETER(SCOMPLEXMATRIXN = 2)
      PARAMETER(SCOMPLEXMATRIXL = 2)
      INTEGER   DCOMPLEXMATRIXM 
      INTEGER   DCOMPLEXMATRIXN
      INTEGER   DCOMPLEXMATRIXL
      PARAMETER(DCOMPLEXMATRIXM = 2)
      PARAMETER(DCOMPLEXMATRIXN = 2)
      PARAMETER(DCOMPLEXMATRIXL = 2)

      INTEGER   INTMATRIX(INTMATRIXL,INTMATRIXN)
      CHARACTER CHARMATRIX(CHARMATRIXL,CHARMATRIXN)
      CHARACTER BYTEMATRIX(BYTEMATRIXL,BYTEMATRIXN)
      REAL      FLOATMATRIX(FLOATMATRIXL,FLOATMATRIXN)
      DOUBLE    PRECISION DOUBLEMATRIX(DOUBLEMATRIXL,DOUBLEMATRIXN)
      COMPLEX   SCOMPLEXMATRIX(SCOMPLEXMATRIXL,SCOMPLEXMATRIXN)
      DOUBLE    COMPLEX DCOMPLEXMATRIX(DCOMPLEXMATRIXL,DCOMPLEXMATRIXN)
  
      INTEGER ONE
C 
C  Generating the random mxm matrices, as well as the
C   random right hand sides.
C 

      WRITE(*,*) '** Test #1 : Blocking call to "dgesv" **'

      INIT = 1325
      M = 200
      DO 10 I = 1,M
        DO 11 J = 1,M
          INIT = MOD(2315*INIT,65536)
          A1(J,I) = (DBLE(INIT) - 32768.D0)/16384.D0
11      CONTINUE
10    CONTINUE

      DO 12 I = 1,M
        INIT = MOD(2315*INIT,65536)
        B1(I) = (DBLE(INIT) - 32768.D0)/16384.D0
12    CONTINUE

C    Calling Netsolve for 'dgesv' in a blocking fashion 
C    For 'dgesv', the right-hand side is overwritten    
C    with the solution                                  

      ONE = 1
      CALL FNETSL('dgesv()',INFO,M,ONE,A1,MAX,PIVOT,B1,MAX,IERR)
      IF (INFO.LE.0) THEN
        CALL FNETSLERR(INFO)
        WRITE(*,*) '** Failure **'
      ELSE
        WRITE(*,*) '*************'
        WRITE(*,*) '** Success **'
        WRITE(*,*) '*************'
      ENDIF

C    Calling Netsolve for 'dgesv' in a non-blocking fashion   
C    For 'dgesv', the right-hand side is overwritten          
C    with the solution                                        

      WRITE(*,*) '** Test #2 : Non-blocking call and probing **'

      CALL FNETSLNB('dgesv()',REQUEST,M,1,A1,MAX,PIVOT,B1,MAX,IERR)
      IF (REQUEST.LT.0) THEN
        CALL FNETSLERR(REQUEST)
        WRITE(*,*) '** Failure **'
      ELSE
30      CONTINUE
          CALL FNETSLPR(REQUEST,INFO)
          IF (INFO.NE.NetSolveNotReady) THEN
            GOTO 31
          ENDIF
        GOTO 30
31      CONTINUE
        IF (INFO.LT.0) THEN
          CALL FNETSLERR(INFO)
          WRITE(*,*) '** Failure **'
        ELSE
          WRITE(*,*) '*************'
          WRITE(*,*) '** Success **'
          WRITE(*,*) '*************'
        ENDIF
      ENDIF

C    Calling Netsolve for 'dgesv' in a non-blocking fashion   
C    For 'dgesv', the right-hand side is overwritten          
C    with the solution                                        

      WRITE(*,*) '** Test #3 : Non-blocking call to "dgesv" and waiting'
      CALL FNETSLNB('dgesv()',REQUEST,M,1,A1,MAX,PIVOT,B1,MAX,IERR)
      IF (REQUEST.LT.0) THEN
        CALL FNETSLERR(REQUEST)
        WRITE(*,*) '** Failure **' 
      ELSE
        CALL FNETSLWT(REQUEST,INFO) 
        IF (INFO.LT.0) THEN
          CALL FNETSLERR(INFO)
          WRITE(*,*) '** Failure **'
        ELSE
          WRITE(*,*) '*************'
          WRITE(*,*) '** Success **'
          WRITE(*,*) '*************'
        ENDIF
        
      ENDIF

C
C  A bunch of requests
C 

      WRITE(*,*) '** Test #4 : ',NB_REQUESTS,' non-blocking requests'

      REQUEST = 1
      DO 40 I=1,NB_REQUESTS
       CALL FNETSLNB('dgesv()',REQUESTS(I),M,1,A1,MAX,PIVOT,B1,MAX,IERR)
        IF (REQUESTS(I).LT.0) THEN
          REQUEST = 0
          CALL FNETSLERR(REQUESTS(I))
        ENDIF
    
40    CONTINUE

      GOON = 1
      
50    IF (GOON.EQ.0) THEN
        GOTO 60
      ENDIF
      GOON = 0
      DO 55 I=1,NB_REQUESTS
        IF (REQUESTS(I).LT.0) THEN
          GOTO 55
        ELSE
          GOON = 1
        ENDIF
        CALL FNETSLPR(REQUESTS(I),INFO)
        IF (INFO.LT.0) THEN
          REQUEST = 0
          CALL FNETSLERR(INFO)
          REQUESTS(I) = -1
        ENDIF 
        IF (INFO.GT.0) THEN
          REQUESTS(I) = -1
        ENDIF
       
55    CONTINUE
      GOTO 50
60    CONTINUE

      IF (REQUEST.EQ.0) THEN
        WRITE(*,*) '** Failure **'
      ELSE
        WRITE(*,*) '*************'
        WRITE(*,*) '** Success **'
        WRITE(*,*) '*************'
      ENDIF 

C
C     TOTAL TEST
C

      WRITE(*,*) '** Test #5 : All data structures/types **'

      OK = 1

C     Assigning the initial values

      INTSCALAR = 2
      CHARSCALAR = 'a'
      BYTESCALAR = 'a'
      FLOATSCALAR = 2.0
      DOUBLESCALAR = 2.D0
      SCOMPLEXSCALAR = (2.0,2.0)
      DCOMPLEXSCALAR = (2.D0,2.D0)

      DO 101 I=1,INTVECTORM
        INTVECTOR(I) = 2
101   CONTINUE
      DO 102 I=1,CHARVECTORM
        CHARVECTOR(I) = 'a'
102   CONTINUE
      DO 103 I=1,BYTEVECTORM
        BYTEVECTOR(I) = 'a'
103   CONTINUE
      DO 104 I=1,FLOATVECTORM
        FLOATVECTOR(I) = 2.0
104   CONTINUE
      DO 105 I=1,DOUBLEVECTORM
        DOUBLEVECTOR(I) = 2.D0
105   CONTINUE
      DO 106 I=1,SCOMPLEXVECTORM
        SCOMPLEXVECTOR(I) = (2.0,2.0)
106   CONTINUE
      DO 107 I=1,DCOMPLEXVECTORM
        DCOMPLEXVECTOR(I) = (2.D0,2.D0)
107   CONTINUE

      DO 110 I = 1,INTMATRIXN
        DO 120 J = 1,INTMATRIXM
          INTMATRIX(J,I) = 2
120     CONTINUE
110   CONTINUE
      DO 111 I = 1,CHARMATRIXN
        DO 121 J = 1,CHARMATRIXM
          CHARMATRIX(J,I) = 'a'
121     CONTINUE
111   CONTINUE
      DO 112 I = 1,BYTEMATRIXN
        DO 122 J = 1,BYTEMATRIXM
          BYTEMATRIX(J,I) = 'a'
122     CONTINUE
112   CONTINUE
      DO 113 I = 1,FLOATMATRIXN
        DO 123 J = 1,FLOATMATRIXM
          FLOATMATRIX(J,I) = 2.0
123     CONTINUE
113   CONTINUE
      DO 114 I = 1,DOUBLEMATRIXN
        DO 124 J = 1,DOUBLEMATRIXM
          DOUBLEMATRIX(J,I) = 2.0
124     CONTINUE
114   CONTINUE
      DO 115 I = 1,SCOMPLEXMATRIXN
        DO 125 J = 1,SCOMPLEXMATRIXM
          SCOMPLEXMATRIX(J,I) =  (2.0,2.0)
125     CONTINUE
115   CONTINUE
      DO 116 I = 1,DCOMPLEXMATRIXN
        DO 126 J = 1,DCOMPLEXMATRIXM
          DCOMPLEXMATRIX(J,I) = (2.D0,2.D0)
126     CONTINUE
116   CONTINUE


C     Calling NetSolve

      CALL FNETSL('totaltest()',INFO,
     $  INTSCALAR,INTVECTOR,INTVECTORM,INTMATRIX,INTMATRIXM,
     $  INTMATRIXN,INTMATRIXL,CHARSCALAR,CHARVECTOR,CHARVECTORM,
     $  CHARMATRIX,CHARMATRIXM,CHARMATRIXN,CHARMATRIXL,
     $  FLOATSCALAR,FLOATVECTOR,FLOATVECTORM,FLOATMATRIX,
     $  FLOATMATRIXM,FLOATMATRIXN,FLOATMATRIXL,DOUBLESCALAR,
     $  DOUBLEVECTOR,DOUBLEVECTORM,DOUBLEMATRIX,DOUBLEMATRIXM,
     $  DOUBLEMATRIXN,DOUBLEMATRIXL,SCOMPLEXSCALAR,SCOMPLEXVECTOR,
     $  SCOMPLEXVECTORM,SCOMPLEXMATRIX,SCOMPLEXMATRIXM,
     $  SCOMPLEXMATRIXN,SCOMPLEXMATRIXL,DCOMPLEXSCALAR,DCOMPLEXVECTOR,
     $  DCOMPLEXVECTORM,DCOMPLEXMATRIX,DCOMPLEXMATRIXM,
     $  DCOMPLEXMATRIXN,DCOMPLEXMATRIXL,BYTESCALAR,BYTEVECTOR,
     $  BYTEVECTORM,BYTEMATRIX,BYTEMATRIXM,BYTEMATRIXN,BYTEMATRIXL)

      If (INFO.LT.0) THEN
        CALL FNETSLERR(INFO)
        WRITE(*,*) '** Failure **'
        OK = 0
      ELSE

C     Checking the validity of the data

C     SCALARS
 
      IF (INTSCALAR.NE.3) THEN
        WRITE(*,*) '  WARNING : Error on the "integer scalar" value' 
        WRITE(*,*) '            ( 3 but got ',INTSCALAR,')'
        OK = 0
      ENDIF
      IF (CHARSCALAR.NE.'b') THEN
        WRITE(*,*) '  WARNING : Error on the "char scalar" value'
        WRITE(*,*) '            ( "b" but got  "',CHARSCALAR,'")'
        OK = 0
      ENDIF
      IF (FLOATSCALAR.NE.3.0) THEN
        WRITE(*,*) '  WARNING : Error on the "float scalar" value'
        WRITE(*,*) '            ( 3.0 but got ',FLOATSCALAR,')'
        OK = 0
      ENDIF
      IF (DOUBLESCALAR.NE.3.D0) THEN
        WRITE(*,*) '  WARNING : Error on the "double scalar" value'
        WRITE(*,*) '            ( 3.D0 but got ',DOUBLESCALAR,')'
        OK = 0
      ENDIF
      IF (SCOMPLEXSCALAR.NE.(3.0,3.0)) THEN
        WRITE(*,*) '  WARNING : Error on the "scomplex scalar" value'
        WRITE(*,*) '  ( 3.0+i*3.0 but got ',SCOMPLEXSCALAR,')'
        OK = 0
      ENDIF
      IF (DCOMPLEXSCALAR.NE.(3.0,3.0)) THEN
        WRITE(*,*) '  WARNING : Error on the "dcomplex scalar" value'
        WRITE(*,*) ' ( 3.D0+i*3.D03 but got ',DCOMPLEXSCALAR,')'
        OK = 0
      ENDIF

C
C No test for bytes
C

C     VECTORS

      DO 200 I=1,INTVECTORM
        IF (INTVECTOR(I).NE.3) THEN
          WRITE(*,*) '  WARNING : Error on the "integer vector" value'
          WRITE(*,*) '            ( 3 but got ',INTVECTOR(I),')'
          OK = 0
        ENDIF
200   CONTINUE
      DO 201 I=1,CHARVECTORM
        IF (CHARVECTOR(I).NE."b") THEN
          WRITE(*,*) '  WARNING : Error on the "char vector" value'
          WRITE(*,*) '          ( "b" but got "',CHARVECTOR(I),'")'
          OK = 0
        ENDIF
201   CONTINUE
      DO 202 I=1,FLOATVECTORM
        IF (FLOATVECTOR(I).NE.3.0) THEN
          WRITE(*,*) '  WARNING : Error on the "float vector" value'
          WRITE(*,*) '         ( 3.0 but got ',FLOATVECTOR(I),')'
          OK = 0
        ENDIF
202   CONTINUE
      DO 203 I=1,DOUBLEVECTORM
        IF (DOUBLEVECTOR(I).NE.3.D0) THEN
          WRITE(*,*) '  WARNING : Error on the "double vector" value'
          WRITE(*,*) '         ( 3.D0 but got ',DOUBLEVECTOR(I),')'
          OK = 0
        ENDIF
203   CONTINUE
      DO 204 I=1,SCOMPLEXVECTORM
        IF (SCOMPLEXVECTOR(I).NE.(3.0,3.0)) THEN
          WRITE(*,*) '  WARNING : Error on the "scomplex vector" value'
          WRITE(*,*) '  ( 3.0+i*3.0 but got ',SCOMPLEXVECTOR(I),')'
          OK = 0
        ENDIF
204   CONTINUE
      DO 205 I=1,DCOMPLEXVECTORM
        IF (DCOMPLEXVECTOR(I).NE.(3.D0,3.D0)) THEN
          WRITE(*,*) '  WARNING : Error on the "dcomplex vector" value'
          WRITE(*,*) '  ( 3.D0+i*3.D0 but got ',DCOMPLEXVECTOR(I),')'
          OK = 0
        ENDIF
205   CONTINUE

C
C No test fo bytes
C

C     MATRIX

      DO 206 I=1,INTMATRIXN
        DO 207 J=1,INTMATRIXM
          IF (INTMATRIX(J,I).NE.3) THEN
            WRITE(*,*) '  WARNING : Error on the "integer matrix" value'
            WRITE(*,*) '            ( 3 but got ',INTMATRIX(J,I),')'
            OK = 0
          ENDIF
207     CONTINUE
206   CONTINUE
      DO 208 I=1,CHARMATRIXN
        DO 209 J=1,CHARMATRIXM
          IF (CHARMATRIX(J,I).NE.'b') THEN
            WRITE(*,*) '  WARNING : Error on the "char matrix" value'
            WRITE(*,*) '    ( b but got  ',CHARMATRIX(J,I),')'
            OK = 0
          ENDIF
209     CONTINUE
208   CONTINUE
      DO 210 I=1,FLOATMATRIXN
        DO 211 J=1,FLOATMATRIXM
          IF (FLOATMATRIX(J,I).NE.3.0) THEN
            WRITE(*,*) '  WARNING : Error on the "float matrix" value'
            WRITE(*,*) '      ( 3.0 but got ',FLOATMATRIX(J,I),')'
            OK = 0
          ENDIF
211     CONTINUE
210   CONTINUE
      DO 212 I=1,DOUBLEMATRIXN
        DO 213 J=1,DOUBLEMATRIXM
          IF (DOUBLEMATRIX(J,I).NE.3.D0) THEN
            WRITE(*,*) '  WARNING : Error on the "double matrix" value'
            WRITE(*,*) '     ( 3.D0 but got ',DOUBLEMATRIX(J,I),')'
            OK = 0
          ENDIF
213     CONTINUE
212   CONTINUE
      DO 214 I=1,SCOMPLEXMATRIXN
        DO 215 J=1,SCOMPLEXMATRIXM
          IF (SCOMPLEXMATRIX(J,I).NE.(3.0,3.0)) THEN
            WRITE(*,*) ' WARNING : Error on the "scomplex matrix" value'
            WRITE(*,*) ' ( 3.0+i*3.0 but got ',SCOMPLEXMATRIX(J,I),')'
            OK = 0
          ENDIF
215     CONTINUE
214   CONTINUE
      DO 216 I=1,DCOMPLEXMATRIXN
        DO 217 J=1,DCOMPLEXMATRIXM
          IF (DCOMPLEXMATRIX(J,I).NE.(3.D0,3.D0)) THEN
            WRITE(*,*) 'WARNING : Error on the "dcomplex matrix" value'
            WRITE(*,*) '(3.D0+i*3.D0 but got ',DCOMPLEXMATRIX(J,I),')'
            OK = 0
          ENDIF
217     CONTINUE
216   CONTINUE

C
C No test for bytes
C

      IF (OK.EQ.0) THEN
        WRITE(*,*) '** Failure **'
      ELSE
        WRITE(*,*) '*************'
        WRITE(*,*) '** Success **'
        WRITE(*,*) '*************'
      ENDIF
    
      ENDIF
 
      STOP
      END

